<template>
    <div>
        <app-layout>
            <template #header>Displays</template>
            <panel>
                <template #header>
                    <button @click="newDispModalOpen = true" class="my-2 ml-6 whitespace-no-wrap items-center px-4 py-2 border border-transparent text-base leading-6 font-medium rounded-md text-white bg-green-500 hover:bg-green-400 focus:outline-none focus:border-green-600 focus:shadow-outline-green active:bg-green-600 transition ease-in-out duration-150">
                        New Display
                    </button>
                </template>
                <input-error :message="newform.error('code')" class="mt-2" />
                <input-error :message="newform.error('domain')" class="mt-2" />
                <table class="table-auto w-full" v-if="displays.length > 0">
                    <thead>
                        <tr>
                            <th class="px-4 py-2">Name</th>
                            <th class="px-4 py-2">Code</th>
                            <th class="px-4 py-2">Show</th>
                            <th class="px-4 py-2">Status</th>
                            <th class="px-4 py-2">Last Seen</th>
                        </tr>
                    </thead>
                    <tbody>
                        <tr class="hover:bg-yellow-200 dark:hover:bg-yellow-900 text-center" v-for="display in displays" :key="display.id" @click="$inertia.get('/displays/'+display.id)">
                            <td class="px-4 py-2">{{display.name}}</td>
                            <td class="px-4 py-2">{{(display.registrations.length > 0)? display.registrations[display.registrations.length - 1].code:"None"}}</td>
                            <td class="px-4 py-2">{{display.show_id || "None"}}</td>
                            <td class="px-4 py-2">{{display.status}}</td>
                            <td class="px-4 py-2">{{(display.heartbeat && display.heartbeat.fromNow)? display.heartbeat.fromNow() :  "Never"}}</td>
                        </tr>
                    </tbody>
                </table>
                <div v-else>
                    No Displays
                </div>
            </panel>
        </app-layout>
        <dialog-modal :show="newDispModalOpen" @close="newDispModalOpen = false">
            <template #title>New Display</template>
            <div class="mb-4">
                <x-label class="mb-2">Display Code</x-label>
                <x-input :value="newform.code" @input="inputCode" :filter="filterCode" placeholder="ABC123" class="py-2 px-3 w-full"/>
                <div class="text-sm text-gray-600 dark:text-gray-400 mt-1">The six-digit code is found on the bottom right of the display.</div>
            </div>
            <div class="mb-4">
                <x-label class="mb-2">Name</x-label>
                <x-input v-model="newform.name" placeholder="My Display" class="w-full py-2 px-3"/>
            </div>
            <template #footer>
                <danger-button @click.native.prevent="newDispModalOpen = false">Cancel</danger-button>
                <x-button class="ml-2" @click.native.prevent="createDisplay">Create</x-button>
            </template>
        </dialog-modal>
    </div>
</template>

<script>
    import Vue from 'vue'
    import dayjs from 'dayjs'
    import relativeTime from 'dayjs/plugin/relativeTime'
    dayjs.extend(relativeTime)

    export default {
        props: {
            displays: Array,
        },
        data(){
            return {
                newDispModalOpen: false,
                newform: this.$inertia.form({
                    name: this.name,
                    code: this.code,
                }, {
                    bag: 'createDisplay',
                    resetOnSuccess: true,
                }),
            }
        },
        mounted(){
            this.displays.forEach(display=>{
                display.created_at = dayjs(display.created_at);
                display.heartbeat = dayjs(display.heartbeat);
                display.updated_at = dayjs(display.updated_at);
            });
        },
        methods: {
            createDisplay(){
                this.newform.post('/displays',{
                    preserveScroll: true,
                    only: ['displays'],
                });
                this.newDispModalOpen = false;
            },
            deleteDisplay(id){
                this.$inertia.delete('/displays/'+id, {
                    preserveScroll: true,
                    onSuccess(page){
                        this.displays = this.displays.filter(function(group){
                            return group.id !== id;
                        });
                    },
                });
            },
            filterCode(e){ // keydown event
                console.log(e);
                if(e.key.length > 1) return;
                if(this.newform.code.length >= 6) e.preventDefault();
                if(!('ABCDEFGHJKMNPQRSTUVWXYZ23456789@#$%&'.split('').includes(e.key.toUpperCase()))) e.preventDefault();
            },
            inputCode(val){
                this.newform.code = val.toUpperCase();
            }
        },
    }
</script>